#ifndef KANJI_UNION_H
#define KANJI_UNION_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#endif

#define VERSION_NUMBER 1.17
#define BLOCK_SIZE 2560
#define BUFFER_SIZE 3712 // strcpy(buffer, getenv("Path") );
#define C_SIZE 256 // FILE_NAME_SIZE + 1
#define C_SJIS_EUC_BIN "C:\\diyoCxx\\MS932~EUC-JP.bin"
#define DATA_ARRAY_LIMIT 906
#define DO_NOT_SEARCH_TABLE "-d"
#define DOUBLE_KANJI 4 // SJIS_KANJI_SIZE + EUC_KANJI_SIZE
#define DUAL_KANJI 4 // SJIS_KANJI_SIZE + SJIS_KANJI_SIZE
#define ERROR_TEXT "error.txt"
#define EUC_KANJI_SIZE 2
#define EUC_KANJI_SIZE_1 3
#define FILE_NAME_SIZE 255
#define FINAL_LINE 11
#define FIRST_KANJI 159
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KANJI_SIZE 2
#define KATAKANA_SIZE 1
#define NORMAL_ARRAY_SIZE 3
#define RECORD_COUNT 7882
#define RIGHT_ARROW "  " // Shift_JIS
#define SEARCH_COUNT 4
#define SEARCH_COUNT_1 3 // SEARCH_COUNT - 1
#define SETTING_TEXT "setting.txt"
#define SJIS_KANJI_SIZE 2
#define SJIS_EUC_BIN "MS932~EUC-JP.bin"
#define SUBSTITUTE_ARRAY_SIZE 3
#define WHICH_TABLE "-w"
#define ZERO "0"
#include <stdio.h>
#include <stdlib.h> // getenv()
#include "Dividing.h"

typedef bool (*OPEN_CLOSE_FUNCTION)(char *buffer, int buffer_size);

typedef union KANJI KANJI;
union KANJI {
    unsigned char sequence[6];
    unsigned short code[3];
    unsigned int block;
};

typedef struct NORMAL_SUBSTITUTE NORMAL_SUBSTITUTE;
struct NORMAL_SUBSTITUTE {
    bool please_check;
    std::string normal;
    std::string substitute;
};

class CommandPath {
    char *data;

public:
    CommandPath() {
        data = new char[BUFFER_SIZE];
        strcpy(data, getenv("Path") );
    }

    ~CommandPath() {
        delete[] data;
    }

    char *path_name(char *extra);
    std::string pathName(const char *extra);
};

class SparseEUC {
    char *sparse;
    int size;

public:
    SparseEUC() {
        size = 0xFC4C * EUC_KANJI_SIZE_1;
        sparse = new char[size];
    }

    ~SparseEUC() {
        delete[] sparse;
    }

    void clear() {
        memset(sparse, 0, size);
    }

    void populated(int index, int place, char c) {
        int k = index * EUC_KANJI_SIZE_1 + place;
        *(sparse + k) = c;
    }

    bool setting(bool acquire_from_text, bool no_searching, bool *whichTable);
    std::string working(int index);
    unsigned char working(int index, int place);
};

bool editManyRecords(std::string & text, std::string & binaryName, bool acquire_from_text, bool no_searching, bool *whichTable);
bool editRecord(std::string & normal, std::string & substitute, std::string & binaryName, bool acquire_from_text, bool no_searching, bool *whichTable);
bool binary_file_in_current_directory(char *buffer, int buffer_size);
bool binary_file_in_installed_directory(char *buffer, int buffer_size);
bool binary_file_in_path_directory(char *buffer, int buffer_size);
bool binary_file_in_specified_directory(char *buffer, int buffer_size);
bool openClose(std::string & fileName);
int inverted(char *c);
int kanjiCode(std::string & line);
void errorHandler(const char *p, const char *q);
void acquire_parameters_from_text(const char *parameters_text, char *binaryName, char *normal, char *priority_name, char *substitute, char *text_of_substitutes_list, bool *no_searching, bool *which_table);
void versionGuide(double v, bool comments);

#endif // KANJI_UNION_H
