#include "kanji_union.h"

void ACE_should_disappear() {
    using namespace std;

    ifstream aceFile(ACE, ios::in | ios::binary );
    aceFile.seekg(0, ios_base::end);
    long size = (long)aceFile.tellg();
    if(size > 0) {
        errorHandler("ACE should disappear. Please remove ACE from the current directory. ");
        exit(1);
    }

}

void binary_files_are_accessible_to_SideAce() {
    using namespace std;

    const int SEARCH = SEARCH_COUNT + 2 * NON_EUC_SEARCH;

    bool perfect = true;
    bool euc_phase = true;
    bool utf8_phase = false;
    char buffer[BLOCK_SIZE];
    int buffer_size = BLOCK_SIZE;
    OPEN_CLOSE_FUNCTION *openClose = new OPEN_CLOSE_FUNCTION[SEARCH];

    openClose[0] = binary_file_in_installed_directory; // EUC phase
    openClose[1] = binary_file_in_current_directory; // EUC phase
    openClose[2] = binary_file_in_path_directory; // EUC phase
    openClose[3] = binary_file_in_specified_directory; // EUC phase
    openClose[4] = sjis_utf8_file_in_installed_directory; // UTF8 phase
    openClose[5] = sjis_utf8_file_in_current_directory; // UTF8 phase
    openClose[6] = sjis_utf8_file_in_path_directory; // UTF8 phase
    openClose[7] = ms932_sjis_file_in_installed_directory;
    openClose[8] = ms932_sjis_file_in_current_directory;
    openClose[9] = ms932_sjis_file_in_path_directory;

    for(int i = 0; i < SEARCH; ++i) {
        if( openClose[i](buffer, buffer_size) ) {
            if(euc_phase) {
                i = 3; // end of EUC phase
                euc_phase = false;
                utf8_phase = true;
                continue;
            } else if(utf8_phase) {
                i = 6; // end of UTF8 phase
                euc_phase = false;
                utf8_phase = false;
            } else {
                break; // SideAce can open three binary files: MS932~EUC-JP.bin, MS932~UTF-8.bin and MS932~Shift_JIS.bin
            }

        } else {
            switch(i) {
            case 3:
                perfect = false;
                errorHandler("openClose[", i, "]() error-1: ", buffer);
                i = SEARCH;
                break;
            case 6:
                perfect = false;
                messagesText("openClose[", i, "]() error-2: ", buffer);
                i = SEARCH;
                break;
            default:
                break;
            } // switch

        } // if

    } // for

    delete[] openClose;

    if(! perfect) {
        errorHandler(SJIS_EUC_BIN, "is needed to convert ACE from Shift_JIS to EUC-JP.", SJIS_UTF8_BIN, "is needed to convert ACE from Shift_JIS to UTF-8.");
        exit(1);
    }

}
