#include "dividing.h"

bool STOP = true;

/*
typedef char* FIELD_POINTER;
*/
FIELD_POINTER array_of_fields[FIELD_COUNT];
FIELD_POINTER *fields_list = & array_of_fields[0];

static int BOND_SIZE = sizeof(char);

static bool full_house[256] = {
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, 
    true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true
};

bool Dividing::attempt_to_provide_buffers(bool stop) {
    using namespace std;

    bool vain = false;
    int phase = BUFFER;

    try {
        buffer = new char[buffer_size];

        phase = COMBO;
        combo = new char[ MINIMUM_COMBO_SIZE + buffer_size ];

        phase = SELECTED;
        selected = new bool[ sizeof(bool) * ( field_count + 1 ) ];
        allocated = true;

    } catch(...) {
        stringstream os;
        os << "new char[] error-1: buffer_size = " << buffer_size << "( phase = " << phase << " )";
        messages = os.str();
        vain = true;

        if(stop) {
            errorHandler(messages);
            exit(1);
        }

    }

    return vain;
}

bool Dividing::full_house_attempt_to_provide_buffers(bool stop) {
    using namespace std;

    bool vain = false;
    int phase = BUFFER;

    try {
        buffer = new char[buffer_size];

        phase = COMBO;
        combo = new char[ MINIMUM_COMBO_SIZE + buffer_size ];

        selected = full_house;
        allocated = false;

    } catch(...) {
        stringstream os;
        os << "new char[] error-2: buffer_size = " << buffer_size << "( phase = " << phase << " )";
        messages = os.str();
        vain = true;

        if(stop) {
            errorHandler(messages);
            exit(1);
        }

    }

    return vain;
}

int Dividing::search_separator(char *p, int beginning) {
    bool no_splitting = false;
    int k, n;
    int s = NOT_RECOGNIZED;
    unsigned char uc;

    buffer[ buffer_size - 1 ] = '\0';
    strncpy(buffer, p, buffer_size - 1 );

    for(k = beginning; buffer[k]; k++) {
        uc = (unsigned char)buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == QUOTE) {
                no_splitting = false;
            }

            continue; // Commas disappear if placed in quotes.
        }

// splitting
        if(n == QUOTE) {
            no_splitting = true;
        } else if(n == separator) {
            s = k;
            break;
        }

    }

    return s;
}

void Dividing::vector_to_array_arranging_in_reverse_order() {
    using namespace std;

    char *p;
    int k = 0;
    string s;

    try {
        for(FIELDS_ARRAY::reverse_iterator i = a.rbegin(); i != a.rend(); ++i) {
            s = *i;

            p = new char[buffer_size];
            strcpy(p, s.c_str() );
            fields_list[k++] = p;
        }

    } catch(...) {
        errorHandler("new char[] error-3:", buffer_size, "bytes");
        exit(1);
    }

}

void Dividing::vector_to_array_complementing(char *extra, int bond) {
    using namespace std;

    char *p;
    char delimiter[2] = {0, 0};
    int extra_size = strlen(extra);
    int k = 0;
    int m;
    int size = buffer_size + BOND_SIZE + extra_size + 1;
    string s;

    m = 0x00FF & bond;
    delimiter[0] = (char)m;

    try {
        for(FIELDS_ARRAY::iterator i = a.begin(); i != a.end(); ++i) {
            s = *i;

            p = new char[size];
            strcpy(p, s.c_str() );
            strcat(p, delimiter);
            strcat(p, extra);

            fields_list[k++] = p;
        }

    } catch(...) {
        errorHandler("new char[] error-4:", size, "bytes");
        exit(1);
    }

}

void Dividing::vector_to_array_editing(EDIT_FUNCTION editing, int field_number) {
    using namespace std;

    char *b;
    char *p;
    int field_number_1 = field_number - 1;
    int k = 0;
    int SIZE = buffer_size * EDIT_FUNCTION_FACTOR;
    int SIZE_1 = SIZE - 1;
    string s;

    try {
        for(FIELDS_ARRAY::iterator i = a.begin(); i != a.end(); ++i) {
            s = *i;

            p = new char[SIZE];

            if(k == field_number_1) {
                b = new char[buffer_size];
                strcpy(b, s.c_str() );

                p[SIZE_1] = '\0';
                strncpy(p, editing(b), SIZE_1);

                delete[] b;
            } else {
                strcpy(p, s.c_str() );
            }

            fields_list[k++] = p;
        }

    } catch(...) {
        errorHandler("new char[] error-5:", SIZE, "bytes");
        exit(1);
    }

}

void Dividing::vector_to_array_mapping() {
    using namespace std;

    char *p;
    int k = 0;
    string s;

    try {
        for(FIELDS_ARRAY::iterator i = a.begin(); i != a.end(); ++i) {
            s = *i;

            p = new char[buffer_size];
            strcpy(p, s.c_str() );
            fields_list[k++] = p;
        }

    } catch(...) {
        errorHandler("new char[] error-6:", buffer_size, "bytes");
        exit(1);
    }

}

int Dividing::complementing_fields_list(char *p, char *extra, int bond) {
    smashed_to_pieces(p);

    vector_to_array_complementing(extra, bond);
    return field_count;
}

int Dividing::editing_fields_list(char *p, EDIT_FUNCTION editing, int field_number) {
    smashed_to_pieces(p);

    vector_to_array_editing(editing, field_number);
    return field_count;
}

int Dividing::mapping_fields_list(char *p) {
    smashed_to_pieces(p);

    vector_to_array_mapping();
    return field_count;
}

int Dividing::reversing_fields_list(char *p) {
    smashed_to_pieces(p);

    vector_to_array_arranging_in_reverse_order();
    return field_count;
}

int Dividing::smashed_to_pieces(char *p) {
    using namespace std;

    bool no_splitting = false;
    char *q;
    int field_number = 1;
    int k, n;
    int m = 0;
    unsigned char uc;

    buffer[ buffer_size - 1 ] = '\0';
    strncpy(buffer, p, buffer_size - 1 );

    q = strchr(buffer, '\n');
    if(q == NULL) {
        if(buffer_size != UNBROKEN_BUFFER_SIZE) {
            stringstream om;
            om << "0Ah is not included in a buffer of " << buffer_size << " bytes.";
            messages = om.str();
            errorHandler(messages);
//            exit(1);
        }

    } else {
        *q = '\0';
    }

    string *d = new string("");
    for(k = 0; buffer[k]; k++) {
        uc = (unsigned char)buffer[k];
        n = (int)uc;

        if(no_splitting) {
            if(n == QUOTE) {
                no_splitting = false;
                if(selected[field_number]) {
                    combo[m++] = buffer[k];
                }

            } else if(n == separator) {
                if(remove_separators) {
                    continue;
                } else {
                    if(selected[field_number]) {
                        combo[m++] = buffer[k];
                    }

                }

            } else {
                if(selected[field_number]) {
                    combo[m++] = buffer[k];
                }

            }

            continue;
        }

// splitting
        if(n == QUOTE) {
            no_splitting = true;
            if(selected[field_number]) {
                combo[m++] = buffer[k];
            }

        } else if(n == separator) {
            if(selected[field_number]) {
                combo[m] = '\0';
                delete d;
                d = new string(combo);
                a.push_back(*d); // FIELDS_ARRAY
            }

            m = 0;
            field_number += 1;
            if(field_number > field_count) {
                break;
            }

        } else {
            if(selected[field_number]) {
                combo[m++] = buffer[k];
            }

        }

    }

    if(m > 0) {
        if(selected[field_number]) {
            combo[m] = '\0';
            delete d;
            d = new string(combo);
            a.push_back(*d); // FIELDS_ARRAY
        }

    } else {
        field_number -= 1;
    }

    field_count = field_number;
    delete d;
    return m;
}

Dividing::Dividing(int s) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    field_count = FIELD_COUNT;
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(int s, bool r) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    field_count = FIELD_COUNT;
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(int s, char f) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = false;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Dividing::Dividing(int s, char f, bool r) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = r;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Dividing::Dividing(int s, int f) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(int s, int f, bool r) {
    buffer_size = UNBROKEN_BUFFER_SIZE;
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(long z, int s) {
    buffer_size = (int)z;
    field_count = FIELD_COUNT;
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(long z, int s, bool r) {
    buffer_size = (int)z;
    field_count = FIELD_COUNT;
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(long z, int s, char f) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    remove_separators = false;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Dividing::Dividing(long z, int s, char f, bool r) {
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    remove_separators = r;
    separator = s;

    full_house_attempt_to_provide_buffers(STOP);
}

Dividing::Dividing(long z, int s, int f) {
    buffer_size = (int)z;
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(long z, int s, int f, bool r) {
    buffer_size = (int)z;
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        selected[ m + 1 ] = true;
    }

}

Dividing::Dividing(char *p, int s, char f) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    pattern = p;
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::Dividing(char *p, int s, char f, bool r) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = UNBROKEN_BUFFER_SIZE;
    pattern = p;
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::Dividing(char *p, int s, int f) {
    int c;

    buffer_size = UNBROKEN_BUFFER_SIZE;
    pattern = p;
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::Dividing(char *p, int s, int f, bool r) {
    int c;

    buffer_size = UNBROKEN_BUFFER_SIZE;
    pattern = p;
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::Dividing(char *p, long z, int s, char f) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    pattern = p;
    remove_separators = false;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::Dividing(char *p, long z, int s, char f, bool r) {
    int c;
    unsigned char uc = (unsigned char)f;
    field_count = (int)uc; // 0 to 255

    buffer_size = (int)z;
    pattern = p;
    remove_separators = r;
    separator = s;

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::Dividing(char *p, long z, int s, int f) {
    int c;

    buffer_size = (int)z;
    pattern = p;
    remove_separators = false;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::Dividing(char *p, long z, int s, int f, bool r) {
    int c;

    buffer_size = (int)z;
    pattern = p;
    remove_separators = r;
    separator = s;

    field_count = f;
    if(field_count > FIELD_COUNT) {
        field_count = FIELD_COUNT;
    }

    attempt_to_provide_buffers(STOP);

    for(int m = 0; m < field_count; ++m) {
        c = (int)p[m];
        selected[ m + 1 ] = (c == SET) ? true : false;
    }

}

Dividing::~Dividing() {
    for(int i = 0; i < field_count; ++i) {
        delete fields_list[i];
    }

    delete[] buffer;
    delete[] combo;

    if(allocated) {
        delete[] selected;
    }

    buffer = NULL;
    combo = NULL;
    selected = NULL;
}

std::string Dividing::reverse_unite(char *p) {
    using namespace std;

    int u = 0x00FF & separator;
    unsigned char uc = (unsigned char)u;

    smashed_to_pieces(p);
    stringstream os;
    for(FIELDS_ARRAY::reverse_iterator i = a.rbegin(); i != a.rend(); ++i) {
        os << *i << uc;
    }

    return os.str();
}

std::string Dividing::unite(char *p) {
    using namespace std;

    int u = 0x00FF & separator;
    unsigned char uc = (unsigned char)u;

    smashed_to_pieces(p);
    stringstream os;
    for(FIELDS_ARRAY::iterator i = a.begin(); i != a.end(); ++i) {
        os << *i << uc;
    }

    return os.str();
}

std::string Dividing::unite(char *p, bool listed) {
    using namespace std;

    int u = 0x00FF & separator;
    unsigned char uc = (unsigned char)u;

    if(! listed) {
        mapping_fields_list(p);
    }

    stringstream os;
    for(int i = 0; i < field_count; ++i) {
        os << fields_list[i] << uc;
    }

    return os.str();
}

void Dividing::unite(FIELDS_ARRAY & a, char *p, char *combo) {
    char delimiter[2] = {0, 0};
    int m;

    if( a.empty() ) {
        mapping_fields_list(p);
    }

    m = 0x00FF & separator;
    delimiter[0] = (char)m;
    combo[0] = '\0';
    for(int k = 0; k < field_count; ++k) {
        strcat(combo, fields_list[k]);
        strcat(combo, delimiter);
    }

}

void supplying_bits(char *p, int *field_count) {
    if(*field_count > FIELD_COUNT) {
        *field_count = FIELD_COUNT;
    }

    memset(p, SET, *field_count);
}

void surge_of_set_bits(char *pattern, int field_count, int from, int to) {
// 0011111000000000000, for example
    char *p = pattern;
    int surge_length = to - from + 1;
    int from_1 = from - 1;

    if(surge_length > field_count) {
        surge_length = field_count;
        memset(pattern, SET, surge_length);
        pattern[surge_length] = '\0';
    } else {
        p[field_count] = '\0';
        memset(p, CLEAR, field_count);

        p += from_1;
        memset(p, SET, surge_length);
    }

}

