#include "kanji_union.h"

void versionGuide(double v, bool comments) {
    using namespace std;

    ofstream versionFile(VERSION_TEXT);
    versionFile << "SideAce VCL Version " << v << "\n" << endl;

    if(comments) {
        versionFile << "sideace -c4                 # Move the sideace window to Corner-4. " << endl
            << "sideace -e1                 # 1: EUC-JP. 2: Shift_JIS. 3: UTF-8 " << endl
            << "sideace -e1 -k -aN         #  is subsituted with N. " << endl // Shift_JIS
            << "sideace -e1 -s@ -gP       # @ is subsituted with P. " << endl
            << "sideace -e1 -s@ -gP -d    # Do not search a table. " << endl
            << "sideace -e1 -s@ -gP -q    # Do not produce the sideace window. " << endl
            << "sideace -e1 -s@ -gP -w    # -w shows which table sideace uses. " << endl
            << "sideace -e1 -t bars.txt     # Edit MS932~EUC-JP.bin according to bars.txt " << endl
            << "sideace -e1 -u              # Do not edit MS932~EUC-JP.bin " << endl
            << "sideace -e1 -u -a SJIS EUC  # SJIS has the same time as EUC. " << endl
            << "sideace -e1 -u -y           # Do not remove binary.tmp " << endl
            << "sideace -e2 -i              # Skip control characters. " << endl
            << "sideace -f                  # We can recognize sideace VCL from the title bar." << endl
            << "sideace -n                  # A number appears at the beginning of each line. " << endl
            << "sideace -p                  # PDF help " << endl
            << "sideace -V                  # version " << endl
            << "sideace -VC                 # version with comments " << endl;
    } else {
        versionFile << "sideace -c4                 " << endl
            << "sideace -e1                 " << endl
            << "sideace -e1 -k -aN         " << endl
            << "sideace -e1 -s@ -gP       " << endl
            << "sideace -e1 -s@ -gP -d    " << endl
            << "sideace -e1 -s@ -gP -q    " << endl
            << "sideace -e1 -s@ -gP -w    " << endl
            << "sideace -e1 -t bars.txt     " << endl
            << "sideace -e1 -u              " << endl
            << "sideace -e1 -u -a SJIS EUC  " << endl
            << "sideace -e1 -u -y           " << endl
            << "sideace -e2 -i              " << endl
            << "sideace -f                  " << endl
            << "sideace -n                  " << endl
            << "sideace -p                  " << endl
            << "sideace -V                  " << endl
            << "sideace -VC                 " << endl;
    }

    exit(1);
}
