//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "RecordForm.h"
//---------------------------------------------------------------------------
#include "kanji_union.h"
#include "RecordForm.h"
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
extern FinalEffect *finalEffect;
TForm2 *Form2;

namespace {
    AnsiString MS932 = "@"; // MS932
    const int RECORD_HEIGHT = 142;
    const int RECORD_WIDTH = 143;
}

bool TForm2::singleRecord() {
    using namespace std;

    AnsiString n = Edit1->Text;
    string normal( n.c_str() );
    int from = kanjiCode(normal);

    AnsiString e = Edit2->Text;
    string substitute( e.c_str() );
    int into = kanjiCode(substitute);

    string m = infoText(from, RIGHT_ARROW, into);
    AnsiString a( m.c_str() );
    statusBarText = a;
    Label1->Caption = statusBarText;

    bool no_searching = finalEffect->noSearching();
    string binaryName = finalEffect->tableName();
    bool result = editRecord(normal, substitute, binaryName, no_searching, finalEffect->whichFile() );
    return result;
}

bool TForm2::testKanji() {
    using namespace std;

    AnsiString n = Edit1->Text;
    bool no_searching = finalEffect->noSearching();
    char c[SMALL_BUFFER_SIZE];
    int k;
    SparseSJIS *sjis = new SparseSJIS();
    string normal( n.c_str() );

    sjis->clear();
    if(! sjis->setting(no_searching, finalEffect->whichFile() ) ) {
        errorHandler("testKanji() error: sjis->setting(no_searching, finalEffect->whichFile() ) ");
        return false;
    }

    k = kanjiCode(normal);
    stringstream om;
    om << hex << k;
    string m = om.str();

    AnsiString a( m.c_str() );
    statusBarText = a;
    Label1->Caption = statusBarText;

    stringstream os;

    if(k < ZENKAKU_KUHAKU) {
        os << sjis->working(k, 0);
    } else {
        os << sjis->working(k, 0) << sjis->working(k, 1);
    }

    string line = os.str();
    AnsiString edit_text( line.c_str() );
    Edit2->Text = edit_text;
    delete sjis;
    return true;
}

void TForm2::memo() {
/*  C++Builder 5  */
    char buffer[SMALL_BUFFER_SIZE];
    strcpy(buffer, statusBarText.c_str());
    Clipboard()->SetTextBuf(buffer);

/*  C++Builder 10.2
    char buffer[SMALL_BUFFER_SIZE];
    wchar_t wide_buffer[SMALL_BUFFER_SIZE];
    strcpy(buffer, statusBarText.c_str());
    mbstowcs(wide_buffer, buffer, SMALL_BUFFER_SIZE);
    Clipboard()->SetTextBuf(wide_buffer);
*/
}

void TForm2::saveButtenFocused() {
    Button1->SetFocus();
}

__fastcall TForm2::TForm2(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm2::FormCreate(TObject *Sender)
{
    KeyPreview = true;
    Left = ( Screen->Width - RECORD_WIDTH )/2;
    Top = ( Screen->Height - RECORD_HEIGHT )/2;
    Height = RECORD_HEIGHT;
    Width = RECORD_WIDTH;

    std::string m = finalEffect->ms932();
    AnsiString MS932( m.c_str() );
    Edit1->Text = MS932;
    Label1->Height = 24;
    Label1->Width = 127;

    testKanji();
    
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_ESCAPE) {
        Close();
    } else if(Key == VK_HOME) {
        testKanji();
    } else if(Key == VK_F8) {
        memo();
    }

    
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button1Click(TObject *Sender)
{
// Save button
    singleRecord();
    
}
//---------------------------------------------------------------------------

