/*
SideAce VCL Version 1.08
Displaying the SideAce window
Copyright 2019 Sogaya

Borland C++Builder 5
Embarcadero C++Builder 10.2

*/

//---------------------------------------------------------------------------

#include <vcl.h>
#include "kanji_union.h"
#pragma hdrstop
USERES("SideAce.res");
USEFORM("SideAceForm.cpp", Form1);
USEUNIT("Accessible.cpp");
USEUNIT("CommandPath.cpp");
USEUNIT("Dividing.cpp");
USEUNIT("Editing.cpp");
USEUNIT("Guide.cpp");
USEUNIT("messages.cpp");
USEUNIT("Numbered.cpp");
USEUNIT("Regulate.cpp");
USEUNIT("skipping.cpp");
USEUNIT("SparsePopulationEUC.cpp");
USEUNIT("SparsePopulationSJIS.cpp");
USEUNIT("SparsePopulationUTF8.cpp");
USEFORM("RecordForm.cpp", Form2);
USEFORM("VersionForm.cpp", Form3);
//---------------------------------------------------------------------------
extern FIELD_POINTER *fields_list;
FinalEffect *finalEffect;

WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
    binary_files_are_accessible_to_SideAce();
    ACE_should_disappear();
    int exit_code = checkParametersBeforeProducingWindow();

    switch(exit_code) {
    case STOP_CODE:
        return 0;
    case EDIT_ERROR_CODE:
        return exit_code;
    default:
        break;
    }

    try
    {
         Application->Initialize();
         Application->Title = "SideAce VCL";
         Application->CreateForm(__classid(TForm1), &Form1);
         Application->CreateForm(__classid(TForm2), &Form2);
         Application->CreateForm(__classid(TForm3), &Form3);
         Application->Run();
    }
    catch (Exception &exception)
    {
         Application->ShowException(&exception);
    }

    delete finalEffect;
    return 0;
}
//---------------------------------------------------------------------------
int checkParametersBeforeProducingWindow() {
    using namespace std;

    const bool REMOVE_ANCIENT_FILE = false;
    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const char SETTING_TEXT[] = "parameters.txt";
    const int ASCII_SIZE = 1;
    const int ASCII_TERM_SIZE = 2;
    const int DIAGONAL = 3;
    const int ERROR_CODE = 1;
    const int EUC_TERM_SIZE = 2;
    const int KATAKANA_TERM_SIZE = 2;
    const int NOT_CONVERTED = -1;
    const int SJIS_TERM_SIZE = 2;
    const int STANDARD_BUFFER_SIZE_1 = STANDARD_BUFFER_SIZE - 1;
    char ASCII[] = "-a";
    char CORNER[] = "-c";
    char DIFFERENT_TIME[] = "-t-";
    char DO_NOT_SHOW_WHICH_TABLE_IS_ACCESSIBLE[] = "-w-";
    char EDIT_TABLE[] = "-e";
    char ENCODING[] = "-e";
    char EUC_JP[] = "-g";
    char KATAKANA[] = "-k";
    char MINUS_C4[] = "-c4";
    char NO_SKIPPING[] = "-i-";
    char NON_NUMBER[] = "-n-";
    char READ_DOCUMENT[] = "-r";
    char SEARCH_TABLE[] = "-d-";
    char SHIFT_JIS[] = "-s";
    char TABLE_FILE[] = "-t";
    char UNIX[] = "--unix";
    char UTF8_LF[] = "-8";
    char VERSION_COMMENTS[] = "-VC";
    char VERSION_GUIDE[] = "-V";

    bool carriage_return = true;
    bool document = false;
    bool edit_table = true;
    bool file_to_be_read = true;
    bool full_name = false;
    bool identical_time = false;
    bool line_begins_with_number = false;
    bool list_to_be_read = false;
    bool no_reading = false;
    bool no_removing = true;
    bool no_searching = false;
    bool produce_binary_file = true;
    bool result = true;
    bool skip_control_characters = false;
    bool which_table = false;
    char *argument;
    char *buffer = new char[STANDARD_BUFFER_SIZE];
    char *edge;
    char *p;
    char binary_name[ FILE_NAME_SIZE + 1 ];
    char head[3] = {0, 0, 0};
    char new_name[ FILE_NAME_SIZE + 1 ];
    char normal[NORMAL_ARRAY_SIZE] = {0x87, 0x53, 0}; // S
    char sjis_text[ FILE_NAME_SIZE + 1 ];
    char substitute[SUBSTITUTE_ARRAY_SIZE] = {0x93, 0xF9, 0}; // 
    char text_of_substitutes_list[ FILE_NAME_SIZE + 1 ];
    char underlined[3] = {0x81, 0x51, 0}; // Q
    int corner = DIAGONAL;
    int manager = TO_UTF8;
    int exit_code = 0;
    int size = 0;
    Numbered *n = new Numbered(MINUS_C4);

    memset(buffer, 0, STANDARD_BUFFER_SIZE);
    strncpy(buffer, ::GetCommandLine(), STANDARD_BUFFER_SIZE_1); // C++Builder 5
//    wcstombs(buffer, ::GetCommandLine(), STANDARD_BUFFER_SIZE_1); // C++Builder 10.2

    memset(sjis_text, 0,  FILE_NAME_SIZE + 1 );
    memset(text_of_substitutes_list, 0,  FILE_NAME_SIZE + 1 );

    binary_name[FILE_NAME_SIZE] = '\0';
    strncpy(binary_name, SJIS_EUC_BIN, FILE_NAME_SIZE);

    new_name[FILE_NAME_SIZE] = '\0';
    strncpy(new_name, SIDE_ACE_TEXT, FILE_NAME_SIZE);

// Acquiring parameters from SETTING_TEXT unless the user removes it.
    acquire_parameters_from_text(SETTING_TEXT, binary_name, normal, substitute, text_of_substitutes_list, &corner, &manager,
 &identical_time, &produce_binary_file, &carriage_return, &no_searching, &full_name, &skip_control_characters, &line_begins_with_number, &document, &no_reading,
 &edit_table, &which_table, &no_removing);

    Dividing *d = new Dividing(' ');
    const int FIELDS = d->mapping_fields_list(buffer);
    for(int i = 1; i < FIELDS; ++i) {
        argument = fields_list[i];

        if( strlen(argument) == 0 ) {
            continue;
        }

        if(! strcmp(argument, CRLF) ) {
            carriage_return = true;
        } else if(! strcmp(argument, DIFFERENT_TIME) ) {
            identical_time = false;
        } else if(! strcmp(argument, DO_NOT_REMOVE_0DH) ) {
            carriage_return = true;
        } else if(! strcmp(argument, DO_NOT_REMOVE_TEMPORARY_BINARY_FILE) ) {
            no_removing = true;
        } else if(! strcmp(argument, DO_NOT_SEARCH_TABLE) ) {
            no_searching = true;
        } else if(! strcmp(argument, DO_NOT_SHOW_WHICH_TABLE_IS_ACCESSIBLE) ) {
            which_table = false;
        } else if(! strcmp(argument, EDIT_TABLE) ) {
            edit_table = true;
        } else if(! strcmp(argument, IDENTICAL_TIME) ) {
            identical_time = true;
        } else if(! strcmp(argument, LF) ) {
            carriage_return = false;
        } else if(! strcmp(argument, LINE_FEED) ) {
            carriage_return = false;
        } else if(! strcmp(argument, RECOGNIZE_FULL_NAME) ) {
            full_name = true;
        } else if(! strcmp(argument, NO_EDITING) ) {
            edit_table = false;
        } else if(! strcmp(argument, NO_READING) ) {
            no_reading = true; // Do not produce the SideAce window.
        } else if(! strcmp(argument, NO_SKIPPING) ) {
            skip_control_characters = false;
        } else if(! strcmp(argument, NON_NUMBER) ) {
            line_begins_with_number = false;
        } else if(! strcmp(argument, NUMBER) ) {
            line_begins_with_number = true;
        } else if(! strcmp(argument, READ_DOCUMENT) ) {
            no_reading = false;
        } else if(! strcmp(argument, SEARCH_TABLE) ) {
            no_searching = false;
        } else if(! strcmp(argument, SEE_PDF) ) {
            document = true;
        } else if(! strcmp(argument, SKIPPING) ) {
            skip_control_characters = true;
        } else if(! strcmp(argument, TABLE_FILE) ) {
            list_to_be_read = true;
        } else if(! strcmp(argument, TEMPORARY_BINARY_FILE) ) {
            produce_binary_file = true;
        } else if(! strcmp(argument, UNIX) ) {
            carriage_return = false;
            manager = TO_EUC;
        } else if(! strcmp(argument, UTF8_LF) ) {
            carriage_return = false;
            manager = TO_UTF8;
        } else if(! strcmp(argument, VERSION_COMMENTS) ) {
            delete d; delete n;
            versionGuide(VERSION, WITH_COMMENTS);
        } else if(! strcmp(argument, VERSION_GUIDE) ) {
            delete d; delete n;
            versionGuide(VERSION, WITHOUT_COMMENTS);
        } else if(! strcmp(argument, WHICH_TABLE) ) {
            which_table = true;
        } else {
            edge = & argument[0];

            p = strstr(argument, ASCII);
            if(p == edge) {
                memset(substitute, 0, SUBSTITUTE_ARRAY_SIZE);
                p = & argument[ASCII_TERM_SIZE];
                memcpy(substitute, p, ASCII_SIZE);
                continue;
            }

            p = strstr(argument, EUC_JP);
            if(p == edge) {
                memset(substitute, 0, SUBSTITUTE_ARRAY_SIZE);
                p = & argument[EUC_TERM_SIZE];
                memcpy(substitute, p, EUC_KANJI_SIZE);
                continue;
            }

            p = strstr(argument, KATAKANA);
            if(p == edge) {
                memset(normal, 0, NORMAL_ARRAY_SIZE);
                p = & argument[KATAKANA_TERM_SIZE];
                memcpy(normal, p, KATAKANA_SIZE);
                continue;
            }

            p = strstr(argument, SHIFT_JIS);
            if(p == edge) {
                memset(normal, 0, NORMAL_ARRAY_SIZE);
                p = & argument[SJIS_TERM_SIZE];
                memcpy(normal, p, SJIS_KANJI_SIZE);
                continue;
            }

            p = strstr(argument, CORNER);
            if(p == edge) {
                delete n;
                n = new Numbered(argument);
                corner = n->number();
                if( CORNER == n->parameter() ) {
                    if(corner == NOT_CONVERTED) {
                        corner = DIAGONAL;
                    }

                    continue;
                }

                corner = DIAGONAL;
            }

            p = strstr(argument, ENCODING);
            if(p == edge) {
                delete n;
                n = new Numbered(argument);
                manager = n->number();
                if( ENCODING == n->parameter() ) {
                    if(manager == NOT_CONVERTED) {
                        manager = TO_UTF8;
                    }

                    switch(manager) {
                    case TO_EUC:
                        carriage_return = false;
                        break;
                    case TO_UTF8:
                        carriage_return = false;
                        break;
                    default:
                        carriage_return = true;
                        break;
                    }

                    continue;
                }

                manager = TO_UTF8;
            }

            if(edit_table) {
                if(list_to_be_read) {
                    text_of_substitutes_list[FILE_NAME_SIZE] = '\0';
                    strncpy(text_of_substitutes_list, argument, FILE_NAME_SIZE);
                    list_to_be_read = false;
                } else {
                    binary_name[FILE_NAME_SIZE] = '\0';
                    strncpy(binary_name, argument, FILE_NAME_SIZE);
                }

            } else {
                if(identical_time) {
                    if(file_to_be_read) {
                        sjis_text[FILE_NAME_SIZE] = '\0';
                        strncpy(sjis_text, argument, FILE_NAME_SIZE);
                        file_to_be_read = false;
                    }

                    new_name[FILE_NAME_SIZE] = '\0';
                    strncpy(new_name, argument, FILE_NAME_SIZE);
                }

            }

        }

    }

    string b(binary_name);
    string l(normal);
    string s(substitute);
    string text(text_of_substitutes_list);
    finalEffect = new FinalEffect(b, l, s, text, corner, manager, carriage_return, document, full_name, identical_time, line_begins_with_number, no_removing, no_searching, produce_binary_file, skip_control_characters, which_table);

    if(manager == TO_EUC) {
        if(edit_table) {
            size = strlen(text_of_substitutes_list);
            if(size == 0) {
                if( strcmp(substitute, underlined) ) { // substitute does not equals "Q" (8151h)
                    result = editRecord(l, s, b, no_searching, &which_table);
                }

            } else {
                result = editManyRecords(text, b, no_searching, &which_table);
            }

            if(result) {
                if(no_reading) {
                    exit_code = STOP_CODE;
                }

            } else {
                exit_code = EDIT_ERROR_CODE;
            }

        } else {
            if(identical_time) {
                produceBinaryFile(sjis_text, REMOVE_ANCIENT_FILE);
                renameBinaryFile(sjis_text, no_removing);

                Regulate *r = new Regulate(sjis_text, carriage_return, no_searching, which_table);
                exit_code = r->readingAnotherFileToProduceEUC(TEMPORARY_BINARY);
                if(exit_code != ERROR_CODE) {
                    exit_code = renameBinaryFile(new_name, no_removing);
                }

                if(no_reading) {
                    exit_code = STOP_CODE;
                }

                delete r;
                return exit_code;
            }

        }

    }

    delete buffer;
    delete d;
    delete n;

// finalEffect will be used in Editing.cpp, RecordForm.cpp, SideAceForm.cpp, SparsePopulationEUC.cpp, SparsePopulationSJIS.cpp, and SparsePopulationUTF8.cpp
    return exit_code;
}
