//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

/*
SideAce VCL Version 1.08
Displaying the SideAce window
Copyright 2019 Sogaya

Borland C++Builder 5
Embarcadero C++Builder 10.2

*/

#include "kanji_union.h"
#include "RecordForm.h"
#include "SideAceForm.h"
#include "VersionForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
#pragma warn -8012
extern FinalEffect *finalEffect;
extern TForm2 *Form2;
extern TForm3 *Form3;
TForm1 *Form1;

namespace {
    AnsiString SIDE_ACE = "SideAce";
    AnsiString SIDE_ACE_VCL = "SideAce VCL";
    const double BORDER = 38.0;
    const double BOTTOM_ROW = 26.0;
    const double HEAD = 130.0;
    const double MAIN_BORDER = 639.0; // MAIN_WIDTH - BORDER
    const double MAIN_HEAD = 361.0; // MAIN_HEIGHT - HEAD
    const double UPPER_LIMIT = 80.0;
    const int ASCII_SIZE = 1;
    const int BREAK_1 = 2147483646; // 2147483647 - 1
    const int ERROR_CODE = 1;
    const int MAIN_HEIGHT = 491;
    const int MAIN_WIDTH = 677;
    const int MANY_TIMES = 30;
    const int MANY_TIMES_1 = MANY_TIMES - 1;
    const int NEW_LINE_SIZE = 1; // fopen(ACE, "rt");
    const int NONSAMPLING_PERIOD = 300;
    const int PLUS_SIZE = 1;
    const int SLEEPING = 200;
    const int TASK_BAR_HEIGHT = 43;
    const std::string ASCII_KATAKANA = " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~"; // Shift_JIS
    const std::string GAP(" ");
    const std::string NEW_LINE("\x0D\x0A");
    const std::string PLUS("+");
    std::string EUC_JP_ACE("EUC-JP");
    std::string SHIFT_JIS_ACE("Shift_JIS");
    std::string UTF_8_ACE("UTF-8");
}

bool TForm1::readACE() {
    using namespace std;

    bool b = true;
    char *buffer = new char[BUFFER_SIZE];
    char *combo = new char[BUFFER_SIZE];
    char *q;
    int lineNumber = 1;
    int size;
    int UPPER_LIMIT_1 = upperLimit - PLUS_SIZE;
    LINE_NUMBER_FUNCTION lineBegins = nonnumber;
    FILE *aceFile = fopen(ACE, "rt");
    if(aceFile == NULL) {
        errorHandler("fopen() error-2:", ACE);
        return false;
    }

    if( finalEffect->numbering() ) {
        lineBegins = lineBeginsWithNumber;
    }

    string *p = new string("");
    string line, part;
    stringstream os;
    for(;;) {
        q = fgets(buffer, BUFFER_SIZE, aceFile);
        if(q == NULL) {
            break;
        } else {
            q = strchr(buffer, '\n');
            if(q != NULL) {
                *q = '\0';
            }

        }

        p = lineBegins(p, buffer, combo);
        line = *p;

        if(lineNumber <= header) {
            part = fixedWidthFontScreenLinePlus(line, UPPER_LIMIT_1);
            os << part << NEW_LINE;
        }

        v.push_back(line);
        lineNumber = lineNumber + 1;
    }

    string s = os.str();
    AnsiString head( s.c_str() );
    Memo1->Text = head;
/*
SideAceForm.dfm
    Font.Charset = SHIFTJIS_CHARSET
    Font.Color = clWindowText
    Font.Height = -16
    Font.Name = 'lr SVbN'
*/
    delete p;
    delete[] buffer;
    delete[] combo;
    fclose(aceFile);
    return b;
}

int TForm1::columns(int x) {
    double m_BORDER,  x_BORDER, y;
    int n;

    m_BORDER = MAIN_BORDER;
    x_BORDER = x - BORDER;
    y = x_BORDER * UPPER_LIMIT/m_BORDER;
    n = (int)floor(y);
    return n;
}

int TForm1::convert_to_EUC() {
    bool carriage_return = finalEffect->CR_LF();
    bool no_removing = finalEffect->removeBinaryFile();
    bool no_searching = finalEffect->noSearching();
    bool skip_control_characters = finalEffect->skipping();
    bool whichTable = finalEffect->whichBinary();
    Regulate *r = new Regulate(v, carriage_return, no_searching, whichTable);
    int exit_code;

    if(skip_control_characters) {
        exit_code = r->skippingControlCharactersToProduceEUC(TEMPORARY_BINARY);
    } else {
        exit_code = r->readingToProduceEUC(TEMPORARY_BINARY);
    }

    if(exit_code != ERROR_CODE) {
        exit_code = renameBinaryFile(ACE, no_removing);
    }

    delete r;
    return exit_code;
}

int TForm1::convert_to_SJIS() {
    bool skip_control_characters = finalEffect->skipping();
    int exit_code = 0;

    if(skip_control_characters) {
        bool carriage_return = finalEffect->CR_LF();
        bool no_removing = finalEffect->removeBinaryFile();
        bool no_searching = finalEffect->noSearching();
        bool skip_control_characters = finalEffect->skipping();
        bool whichTable = finalEffect->whichBinary();
        Regulate *r = new Regulate(v, carriage_return, no_searching, whichTable);
        exit_code = r->skippingControlCharactersToProduceSJIS(TEMPORARY_BINARY);

        if(exit_code != ERROR_CODE) {
            exit_code = renameBinaryFile(ACE, no_removing);
        }

        delete r;
    } else {
        keepLog();
    }

    return exit_code;
}

int TForm1::convert_to_UTF8() {
    bool carriage_return = finalEffect->CR_LF();
    bool no_removing = finalEffect->removeBinaryFile();
    bool no_searching = finalEffect->noSearching();
    bool skip_control_characters = finalEffect->skipping();
    bool whichTable = finalEffect->whichBinary();
    Regulate *r = new Regulate(v, carriage_return, no_searching, whichTable);
    int exit_code;

    if(skip_control_characters) {
        exit_code = r->skippingControlCharactersToProduceUTF8(TEMPORARY_BINARY);
    } else {
        exit_code = r->readingToProduceUTF8(TEMPORARY_BINARY);
    }

    if(exit_code != ERROR_CODE) {
        exit_code = renameBinaryFile(ACE, no_removing);
    }

    delete r;
    return exit_code;
}

int TForm1::rows(int x) {
    double m_HEAD, x_HEAD, y;
    int n;
    
    m_HEAD = MAIN_HEAD;
    x_HEAD = x - HEAD;
    y = x_HEAD * BOTTOM_ROW/m_HEAD;
    n = (int)floor(y);
    return n;
}

LINE_POINTER lineBeginsWithNumber(LINE_POINTER p, char *buffer, char *combo) {
    using namespace std;

    static int line_number;

    line_number += 1;
    sprintf(combo, "%10d|%s", line_number, buffer);
    delete p;
    p = new string(combo);
    return p;
}

LINE_POINTER nonnumber(LINE_POINTER p, char *buffer, char *combo) {
    using namespace std;

    combo[0] = '\0';
    delete p;
    p = new string(buffer);
    return p;
}

std::string TForm1::fixedWidthFontScreenLinePlus(std::string & line, int limit) {
    using namespace std;

    bool kanji = false;
    char buffer[BLOCK_SIZE];
    int BLOCK_SIZE_1 = BLOCK_SIZE - 1;
    int c;
    int k = 0;
    stringstream os;
    unsigned char firstByte = 0x40;
    unsigned char uc;

    buffer[BLOCK_SIZE_1] = '\0';
    strncpy(buffer, line.c_str(), BLOCK_SIZE_1);

    for(int i = 0; buffer[i]; ++i) {
        uc = (unsigned char)buffer[i];
        c = (int)uc;

        if(kanji) {
            os << firstByte;
            os << uc;
            kanji = false;
            k += KANJI_SIZE;
            if(k >= limit) {
                os << PLUS;
                break;
            }

            continue;
        }

        if(0x81 <= c && c<= 0xFC) {
            if(KANA_KUTEN <= c && c <= KANA_HANDAKUTEN) {
                os << uc;
                kanji = false;
                k += ASCII_SIZE;
            } else {
                firstByte = uc;
                kanji = true;
                continue;
            }

        } else {
            os << uc;
            kanji = false;
            k += ASCII_SIZE;
        }

        if(k >= limit) {
            os << PLUS;
            break;
        }
 
   }

    return os.str();
}

void TForm1::keepLog() {
    using namespace std;

    ofstream aceFile(ACE);
    for(ITEM::iterator i = v.begin(); i != v.end(); ++i) {
        aceFile << *i << endl;
    }

}

void TForm1::largeHandler() {
    WindowState = wsNormal;
    Left = 0;
    Top = 0;
    Width = Screen->Width;
    Height = Screen->Height - TASK_BAR_HEIGHT;
}

void TForm1::moveToCorner() {
    switch(corner) {
    case 0:
        Left = ( Screen->Width - Width )/2;
        Top = ( Screen->Height - Height )/2;
        break;
    case 1:
        Left = 0;
        Top = 0;
        break;
    case 2:
        Left = Screen->Width - MAIN_WIDTH;
        Top = 0;
        break;
    case 3:
        Left = Screen->Width - MAIN_WIDTH;
        Top = Screen->Height - MAIN_HEIGHT - TASK_BAR_HEIGHT;
        break;
    case 4:
        Left = 0;
        Top = Screen->Height - MAIN_HEIGHT - TASK_BAR_HEIGHT;
        break;
    default: // Corner-3
        Left = Screen->Width - MAIN_WIDTH;
        Top = Screen->Height - MAIN_HEIGHT - TASK_BAR_HEIGHT;
        break;
    }

}

void TForm1::seePDF() {
//  ShellExecute(Handle, L"open", L"SideAceVCL.pdf", NULL, NULL, SW_NORMAL); // C++Builder 10.2
    ShellExecute(Handle, "open", "SideAceVCL.pdf", NULL, NULL, SW_NORMAL); // C++Builder 5
}

void TForm1::statusBarMessage(std::string & s) {
    const AnsiString m( s.c_str() );
    statusBarText = m;
    StatusBar1->Panels->Items[0]->Text = statusBarText;
}

__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Version1Click(TObject *Sender)
{
    using namespace std;

    string pdf_name(PDF_FILE_NAME);
    stringstream os;
    os << VERSION;
    string v = os.str();
    Form3->setVersion(pdf_name, v);
    Form3->ShowModal();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Record1Click(TObject *Sender)
{
    Form2->Show();
    Form2->saveButtenFocused();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
// Large button
    largeHandler();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Large1Click(TObject *Sender)
{
    largeHandler();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Standard1Click(TObject *Sender)
{
    WindowState = wsNormal;
    Height = MAIN_HEIGHT;
    Width = MAIN_WIDTH;
    moveToCorner();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ShiftJIS1Click(TObject *Sender)
{
    manager = TO_SJIS;
    statusBarMessage(SHIFT_JIS_ACE);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::UTF81Click(TObject *Sender)
{
    manager = TO_UTF8;
    statusBarMessage(UTF_8_ACE);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::StatusBar1Click(TObject *Sender)
{
    Memo1->Text = " ";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Leave1Click(TObject *Sender)
{
    leaveACE = true;
    Close();
    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Close();
    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    using namespace std;

    KeyPreview = true;
    leaveACE = false;
    StatusBar1->Panels->Items[0]->Text = GetCurrentDir();

    Left = Screen->Width - MAIN_WIDTH;
    Top = Screen->Height - MAIN_HEIGHT - TASK_BAR_HEIGHT;
    Height = MAIN_HEIGHT;
    Width = MAIN_WIDTH;
    header = rows(Height);
    upperLimit = columns(Width);

    Button1->Height = 34;
    Button1->Width = 68;
    Button1->Left = ClientWidth - Button1->Width;
    Button1->Top = ClientHeight - Button1->Height - StatusBar1->Height;

    corner = finalEffect->cornerNumber();
    fullName = finalEffect->longName();
    manager = finalEffect->encodingMethod();
    document = finalEffect->portableDocuemntFormat();
    moveToCorner();

    if(fullName) {
        Caption = SIDE_ACE_VCL;
    } else {
        Caption = SIDE_ACE;
    }

    ofstream aceFile(ACE);
    aceFile << GAP;

    if(document) {
        seePDF();
        Timer3->Enabled = true; // The SideAce window will automatically close.
    } else {
        Timer3->Enabled = false;
    }

    touched = FileAge(ACE);
    Timer1->Interval = NONSAMPLING_PERIOD;
    Timer1->Enabled = true;
    Timer2->Enabled = false;
    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
    if(leaveACE) {
        switch(manager) {
        case TO_EUC:
            convert_to_EUC();
            break;
        case TO_SJIS:
            convert_to_SJIS();
            break;
        case TO_UTF8:
            convert_to_UTF8();
            break;
        default:
            convert_to_UTF8();
            break;
        }

    } else {
        remove(ACE);
    }

    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
    if(Key == VK_END) {
        manager = TO_EUC;
        statusBarMessage(EUC_JP_ACE);
    } else if(Key == VK_F3) {
        Close();
    } else if(Key == VK_F8) {
        Memo1->Text = statusBarText;
    } else if(Key == VK_HOME) {
        convert_to_UTF8();
    } else if(Key == VK_PRIOR) { // Page Up
        manager = TO_UTF8;
        statusBarMessage(UTF_8_ACE);
    }

    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
    Button1->Left = ClientWidth - Button1->Width;
    Button1->Top = ClientHeight - Button1->Height - StatusBar1->Height;
    upperLimit = columns(Width);
    header = rows(Height);
    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    int k = FileAge(ACE);
    if(k != touched) {
        touched = k;
        Timer1->Enabled = false;

        count = 0;
        Timer2->Interval = SLEEPING;
        Timer2->Enabled = true;
    }
    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
    using namespace std;

    count += 1;
    if(count < MANY_TIMES) {
        renewal = readACE();
        if(renewal) {
            Timer2->Enabled = false;

            Timer1->Interval = NONSAMPLING_PERIOD;
            Timer1->Enabled = true;
            count = BREAK_1;
        } else {
            if(count == MANY_TIMES_1) {
                Timer2->Enabled = false;

                errorHandler("Timer2Timer() error:", "count == MANY_TIMES_1");
                Close();
            }

        }

    }
    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
    Close();    
    
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EUCJP1Click(TObject *Sender)
{
    manager = TO_EUC;
    statusBarMessage(EUC_JP_ACE);
}
//---------------------------------------------------------------------------

