#include "kanji_union.h"

extern FinalEffect *finalEffect;

bool sjis_utf8_file_in_current_directory(char *buffer, int buffer_size) {
    using namespace std;

    bool b = true;
    ifstream in(SJIS_UTF8_BIN); // current directory
    if( in.fail() ) {
        b = false;
        memset(buffer, 0, buffer_size);
    } else {
        strcpy(buffer, SJIS_UTF8_BIN);
    }

    return b;
}

bool sjis_utf8_file_in_installed_directory(char *buffer, int buffer_size) {
    using namespace std;

    bool b = true;
    ifstream in(C_SJIS_UTF8_BIN); // directory where SideAce was installed.
    if( in.fail() ) {
        b = false;
        memset(buffer, 0, buffer_size);
    } else {
        strcpy(buffer, C_SJIS_UTF8_BIN);
    }

    return b;
}

bool sjis_utf8_file_in_path_directory(char *buffer, int buffer_size) {
    using namespace std;

    bool b = true;
    CommandPath *c = new CommandPath();
    string included = c->pathName(SJIS_UTF8_BIN); // directory included in Path

    if( included.length() == 0 ) {
        b = false;
        memset(buffer, 0, buffer_size);
    } else {
        strcpy(buffer, included.c_str() );
    }

    delete c;
    return b;
}

bool SparseUTF8::setting(bool no_searching, bool *whichTable) {
    using namespace std;

    char buffer[BLOCK_SIZE];
    char c[DOUBLE_KANJI_UTF8];
    int buffer_size = BLOCK_SIZE;
    int index;
    int manager = finalEffect->encodingMethod();
    OPEN_CLOSE_FUNCTION *openClose = new OPEN_CLOSE_FUNCTION[NON_EUC_SEARCH];
    unsigned char uc;

    openClose[0] = sjis_utf8_file_in_installed_directory;
    openClose[1] = sjis_utf8_file_in_current_directory;
    openClose[2] = sjis_utf8_file_in_path_directory;

    for(int i = 0; i < NON_EUC_SEARCH; ++i) {
        if( openClose[i](buffer, buffer_size) ) {
            if(manager == TO_UTF8) {
                if(*whichTable) {
                    messagesText(buffer, "is primarily accessible to SideAce.");
                    *whichTable = false;
                }

            }

            break;
        } else {
            switch(i) {
            case 0:
                if(no_searching) {
                    errorHandler("openClose[", i, "]() error-11:", SJIS_UTF8_BIN);
                    delete[] openClose;
                    return false;
                }

                break;
            case 2:
                errorHandler("openClose[", i, "]() error-12:", SJIS_UTF8_BIN);
                delete[] openClose;
                return false;
            default: // case 1:
                break;
            }

        }

    }

    ifstream binaryFile(buffer);
    for(int i = 1; i <= RECORD_COUNT; ++i) {
        binaryFile.read(c, DOUBLE_KANJI_UTF8);
        if(i < FIRST_KANJI) {
            uc = (unsigned char)c[0];
            index = (int)uc;
            populated(index, 0, c[SJIS_KANJI_SIZE]);
            populated(index, 1, c[ SJIS_KANJI_SIZE + 1 ]);
            populated(index, 2, c[ SJIS_KANJI_SIZE + 2 ]);
        } else {
            populated( inverted(c), 0, c[SJIS_KANJI_SIZE]);
            populated( inverted(c), 1, c[ SJIS_KANJI_SIZE + 1 ]);
            populated( inverted(c), 2, c[ SJIS_KANJI_SIZE + 2 ]);
        }

    }

    delete[] openClose;
    return true;
}

std::string SparseUTF8::working(int index) {
    using namespace std;

    int k = index * UTF8_KANJI_SIZE_1;
    char *p = sparse + k;
    stringstream os;
    os << p;
    return os.str();
}

unsigned char SparseUTF8::working(int index, int place) {
    int k = index * UTF8_KANJI_SIZE_1 + place;
    char* p = sparse + k;
    unsigned char c = (unsigned char) *p;
    return c;
}
